unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, D2XXUnit, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    StaticText5: TStaticText;
    Button4: TButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Button5: TButton;
    CheckBox2: TCheckBox;
    TrackBar3: TTrackBar;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    Shape9: TShape;
    Shape10: TShape;
    CheckBox3: TCheckBox;
    TrackBar4: TTrackBar;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    Panel1: TPanel;
    Button6: TButton;
    Shape11: TShape;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  global_timer :byte;
  connected :Boolean;
  seq,
  seq2 :byte;
implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
adata :array [0..100] of integer;
num_read,
locx    :Integer;
center  :Tpoint;

begin
memo1.clear;
num_read := Read_USB_Device_Buffer(97);
for locx:=0 to 47 do
   begin
      adata[locx] := FT_In_Buffer[(locx*2)+1];
      adata[locx] := adata[locx]*256;
      adata[locx] := adata[locx]+FT_In_Buffer[(locx*2)+2];
   end;
memo1.lines.add(IntToStr(Num_Read));
for locx:=0 to 47 do memo1.lines.add('sample '+IntToStr(locx)+' = '+IntToStr(adata[locx]));
//for locx:=0 to 47 do adata[locx]:=locx;
//for locx:=0 to 47 do adata[locx]:=random(85)+15;
paintbox1.Canvas.Brush.Color:=clGray;
paintbox1.Canvas.Fillrect(rect(0,0,200,200));
application.processmessages;
paintbox1.Canvas.Pen.Color:=clBlue;
paintbox1.Canvas.Brush.Color:=clBlue;
paintbox1.Canvas.Arc(0,0,200,200,0,0,1,0);
paintbox1.Canvas.Ellipse(90,90,110,110);
//paintbox1.Canvas.MoveTo(0,(paintbox1.Height div 2));
//paintbox1.Canvas.LineTo(Paintbox1.width,(paintbox1.Height div 2));
//paintbox1.Canvas.MoveTo((paintbox1.Width div 2),0);
//paintbox1.Canvas.LineTo((Paintbox1.width div 2),paintbox1.Height);
paintbox1.Canvas.MoveTo(0,100);
paintbox1.Canvas.LineTo(200,100);
paintbox1.Canvas.MoveTo(100,0);
paintbox1.Canvas.LineTo(100,200);

paintbox1.Canvas.Brush.Color:=clRed;
paintbox1.Canvas.Pen.Color:=clRed;
for locx:=0 to 47 do
   begin
      center.x:=round((sin(((locx/47.0)*(2*pi))))*(adata[locx]/spinedit1.value))+100;
      center.y:=round((cos(((locx/47.0)*(2*pi))))*(adata[locx]/spinedit1.value))+100;
      paintbox1.Canvas.ellipse(center.x-2,center.y-2,center.x+2,center.y+2);
//      memo1.lines.add('x = '+IntToStr(Center.x)+' y = '+IntToStr(Center.y));
   end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
x:      Integer;
begin
x:=Open_USB_Device;
if(x>0) then
   begin
      showmessage('Error opening USB port #'+IntToStr(x));
      exit;
   end;
Set_USB_Device_TimeOuts(100,50);

FT_Current_Baud := FT_BAUD_19200;
Set_USB_Device_BaudRate();

FT_Current_DataBits:=FT_DATA_BITS_8;
FT_Current_StopBits:=FT_STOP_BITS_2;
FT_Current_Parity:=FT_PARITY_NONE;
Set_USB_Device_DataCharacteristics();

FT_Current_FlowControl:=FT_FLOW_NONE;
//    FT_FLOW_NONE = $0000;
//    FT_FLOW_RTS_CTS = $0100;
//    FT_FLOW_DTR_DSR = $0200;
//    FT_FLOW_XON_XOFF = $0400;

Set_USB_Device_FlowControl();
Button1.Enabled:=True;
Button3.Enabled:=True;
Button4.Enabled:=True;
Button6.Enabled:=True;
Trackbar1.Enabled:=True;
Trackbar2.Enabled:=True;
Trackbar3.Enabled:=True;
Trackbar4.Enabled:=True;
connected := True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('D');
  application.ProcessMessages;
  Write_USB_Device_Buffer(1);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('L');
  FT_Out_Buffer[1]:=((Trackbar1.Position*5) shr 8);
  FT_Out_Buffer[2]:=((Trackbar1.Position*5) AND $ff);
  application.ProcessMessages;
  Write_USB_Device_Buffer(3);
  StaticText1.Caption:=IntToStr(Trackbar1.Position*5);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('R');
  FT_Out_Buffer[1]:=((Trackbar2.Position*5) shr 8);
  FT_Out_Buffer[2]:=((Trackbar2.Position*5) AND $ff);
  application.ProcessMessages;
  Write_USB_Device_Buffer(3);
  StaticText2.Caption:=IntToStr(Trackbar2.Position*5);
end;


procedure TForm1.Timer1Timer(Sender: TObject);

begin
   if(global_timer > 0) then global_timer := global_timer -1;
   Inc(seq);
   seq := (seq AND $1);
   Inc(seq2);
   seq2 := seq2 AND 3;
   if(checkbox1.Checked = True)then
      begin
         if (seq = 1) then Form1.Button3.Click
         else Form1.button1.click;
      end;
   if(checkbox2.Checked = True)then
      begin
         if (seq2 = 0) then
            begin
               memo1.clear;
               Form1.button4.click;
            end;
      end;
   if(checkbox4.Checked = True)then
      begin
         if (seq2 = 0) then
            begin
               memo1.clear;
               Form1.button6.click;
            end;
      end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
num_read :integer;
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('E');
  application.ProcessMessages;
  Write_USB_Device_Buffer(1);
  global_timer :=2;
  application.ProcessMessages;
  while(global_timer > 0) do application.ProcessMessages;
  num_read := Read_USB_Device_Buffer(97);
  memo1.clear;
  memo1.lines.add(IntToStr(num_read));
  if(FT_In_Buffer[1] = 1) then shape1.Brush.Color:=clRed else  shape1.Brush.Color:=clWhite;
  if(FT_In_Buffer[2] = 1) then shape2.Brush.Color:=clRed else  shape2.Brush.Color:=clWhite;
  if(FT_In_Buffer[3] = 1) then shape3.Brush.Color:=clRed else  shape3.Brush.Color:=clWhite;
  if(FT_In_Buffer[4] = 1) then shape4.Brush.Color:=clRed else  shape4.Brush.Color:=clWhite;
  if(FT_In_Buffer[5] = 1) then shape5.Brush.Color:=clRed else  shape5.Brush.Color:=clWhite;
  if(FT_In_Buffer[6] = 1) then shape6.Brush.Color:=clRed else  shape6.Brush.Color:=clWhite;
  if(FT_In_Buffer[7] = 1) then shape7.Brush.Color:=clRed else  shape7.Brush.Color:=clWhite;
  if(FT_In_Buffer[8] = 1) then shape8.Brush.Color:=clRed else  shape8.Brush.Color:=clWhite;
  for num_read:=0 to 8 do memo1.lines.add(IntToHex(FT_In_buffer[num_read],2));
  application.ProcessMessages;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
Memo1.clear;
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('T');
  FT_Out_Buffer[1]:=((Trackbar3.Position) shr 8);
  FT_Out_Buffer[2]:=((Trackbar3.Position) AND $ff);
  application.ProcessMessages;
  Write_USB_Device_Buffer(3);
  StaticText7.Caption:=IntToStr(Trackbar3.Position);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
var
FT_Out_Buffer :Array[0..1000] of byte;
begin
  If(NOT(Connected)) then exit;
   If(CheckBox3.Checked) then
      begin
        FT_Out_Buffer[0]:=Ord('m');
        application.ProcessMessages;
        Write_USB_Device_Buffer(1);
      end
   else
      begin
        FT_Out_Buffer[0]:=Ord('m');
        application.ProcessMessages;
        Write_USB_Device_Buffer(1);
      end;

   
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
connected := False;
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('s');
  FT_Out_Buffer[1]:=((Trackbar4.Position) shr 8);
  FT_Out_Buffer[2]:=((Trackbar4.Position) AND $ff);
  application.ProcessMessages;
  Write_USB_Device_Buffer(3);
  StaticText8.Caption:=IntToStr(Trackbar4.Position);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
num_read :integer;
begin
  If(NOT(Connected)) then exit;
  FT_Out_Buffer[0]:=Ord('H');
  application.ProcessMessages;
  Write_USB_Device_Buffer(1);
  global_timer :=2;
  application.ProcessMessages;
  while(global_timer > 0) do application.ProcessMessages;
  num_read := Read_USB_Device_Buffer(8);
  memo1.clear;
  memo1.lines.add(IntToStr(num_read));
  if(FT_In_Buffer[1] = 1) then shape11.Brush.Color:=clRed else  shape11.Brush.Color:=clWhite;
  memo1.lines.add(IntToHex(FT_In_buffer[1],2));
  application.ProcessMessages;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
var
FT_Out_Buffer :Array[0..1000] of byte;
begin
  If(NOT(Connected)) then exit;
   If(CheckBox5.Checked) then
      begin
        FT_Out_Buffer[0]:=Ord('U');
        application.ProcessMessages;
        Write_USB_Device_Buffer(1);
      end
   else
      begin
        FT_Out_Buffer[0]:=Ord('u');
        application.ProcessMessages;
        Write_USB_Device_Buffer(1);
      end;
end;

end.
